#include<bits/stdc++.h>
#define all(A) A.begin(), A.end()
using namespace std;

struct RSQ{
	int n;
	vector<int> data;
	RSQ() {}
	RSQ(int n) : n(n){
		data.resize(4 * n + 5);
	}
	void upd(int node, int l, int r, int x, int v){
		if(l == r){
			data[node] += v;
		}
		else{
			int m = (l + r) / 2;
			if(l <= x && x <= m) upd(2 * node + 0, l + 0, m, x, v);
			else 				 upd(2 * node + 1, m + 1, r, x, v);
			data[node] = data[2 * node] + data[2 * node + 1];
		}
	}
	int qry(int node, int l, int r, int ql, int qr){
		if(qr < l || r < ql) return 0;
		else if(ql <= l && r <= qr) return data[node];
		else{
			int m = (l + r) / 2;
			return qry(2 * node + 0, l + 0, m, ql, qr) + 
				   qry(2 * node + 1, m + 1, r, ql, qr);
		}
	}
	void upd(int x){ upd(1, 1, n, x, +1); }
	int qry(int r){ return qry(1, 1, n, 1, r); }
};

int main(){
	int n, m;
	cin >> m;
	vector<pair<int, int>> fishes(m);
	for(int i = 0; i < m; i ++) cin >> fishes[i].first;
	for(int i = 0; i < m; i ++) cin >> fishes[i].second;
	cin >> n;
	vector<pair<int, int>> fishermen(n);
	for(int i = 0; i < n; i ++) cin >> fishermen[i].first;
	for(int i = 0; i < n; i ++) cin >> fishermen[i].second;
	vector<int> ans(n);
	{
		vector<array<int, 4>> events;
		vector<int> compress;
		for(auto [x, y] : fishes){
			events.push_back({x, 1, y - x, -1});
			compress.push_back(y - x);
		}
		for(int i = 0; i < n; i ++){
			auto [x, l] = fishermen[i];
			events.push_back({x, 0, l - x,  i});
			compress.push_back(l - x);
		}
		sort(events.begin(), events.end());
		sort(compress.begin(), compress.end());
		compress.resize(distance(compress.begin(), unique(all(compress))));
		RSQ ds(compress.size());
		for(auto [x, type, key, idx] : events){
			key = (lower_bound(compress.begin(), compress.end(), key) - compress.begin()) + 1;
			if(type == 0) ans[idx] += ds.qry(key);
			if(type == 1) ds.upd(key);
		}
	}
	{
		vector<array<int, 4>> events;
		vector<int> compress;
		for(auto [x, y] : fishes){
			events.push_back({x, 1, y + x, -1});
			compress.push_back(y + x);
		}
		for(int i = 0; i < n; i ++){
			auto [x, l] = fishermen[i];
			events.push_back({x, 0, l + x,  i});
			compress.push_back(l + x);
		}
		sort(events.begin(), events.end(), greater<array<int, 4>>());
		sort(compress.begin(), compress.end());
		compress.resize(distance(compress.begin(), unique(all(compress))));
		RSQ ds(compress.size());
		for(auto [x, type, key, idx] : events){
			key = (lower_bound(compress.begin(), compress.end(), key) - compress.begin()) + 1;
			if(type == 0) ans[idx] += ds.qry(key);
			if(type == 1) ds.upd(key);
		}
	}
	for(auto x : ans){
		cout << x << " ";
	} cout << endl;
}
