#include<bits/stdc++.h>
#define all(A) A.begin(), A.end()
using namespace std;

const int BLOCK = 450;

struct RSQ{
	int n;
	vector<int> data, cache;
	RSQ() {}
	RSQ(int n) : n(n){
		data.resize(n + 5);
	}
	void upd(int x){
		cache.push_back(x);
		if(cache.size() == BLOCK){
			vector<int> delta(n + 5);
			for(auto x : cache) ++ delta[x];
			for(int i = 1; i <= n; i ++) delta[i] += delta[i - 1];
			for(int i = 1; i <= n; i ++) data[i] += delta[i];
			cache.clear();
		}
	}
	int qry(int key){
		int ret = 0;
		for(auto x : cache){
			if(x <= key) ++ ret;
		}
		return ret + data[key];
	}
};

int main(){
	int n, m;
	cin >> m;
	vector<pair<int, int>> fishes(m);
	for(int i = 0; i < m; i ++) cin >> fishes[i].first;
	for(int i = 0; i < m; i ++) cin >> fishes[i].second;
	cin >> n;
	vector<pair<int, int>> fishermen(n);
	for(int i = 0; i < n; i ++) cin >> fishermen[i].first;
	for(int i = 0; i < n; i ++) cin >> fishermen[i].second;
	vector<int> ans(n);
	{
		vector<array<int, 4>> events;
		vector<int> compress;
		for(auto [x, y] : fishes){
			events.push_back({x, 1, y - x, -1});
			compress.push_back(y - x);
		}
		for(int i = 0; i < n; i ++){
			auto [x, l] = fishermen[i];
			events.push_back({x, 0, l - x,  i});
			compress.push_back(l - x);
		}
		sort(events.begin(), events.end());
		sort(compress.begin(), compress.end());
		compress.resize(distance(compress.begin(), unique(all(compress))));
		RSQ ds(compress.size());
		for(auto [x, type, key, idx] : events){
			key = (lower_bound(compress.begin(), compress.end(), key) - compress.begin()) + 1;
			if(type == 0) ans[idx] += ds.qry(key);
			if(type == 1) ds.upd(key);
		}
	}
	{
		vector<array<int, 4>> events;
		vector<int> compress;
		for(auto [x, y] : fishes){
			events.push_back({x, 1, y + x, -1});
			compress.push_back(y + x);
		}
		for(int i = 0; i < n; i ++){
			auto [x, l] = fishermen[i];
			events.push_back({x, 0, l + x,  i});
			compress.push_back(l + x);
		}
		sort(events.begin(), events.end(), greater<array<int, 4>>());
		sort(compress.begin(), compress.end());
		compress.resize(distance(compress.begin(), unique(all(compress))));
		RSQ ds(compress.size());
		for(auto [x, type, key, idx] : events){
			key = (lower_bound(compress.begin(), compress.end(), key) - compress.begin()) + 1;
			if(type == 0) ans[idx] += ds.qry(key);
			if(type == 1) ds.upd(key);
		}
	}
	for(auto x : ans){
		cout << x << " ";
	} cout << endl;
}
