#include<bits/stdc++.h>
#define all(A) A.begin(), A.end()
using namespace std;

struct RSQ{
	int n;
	vector<int> data;
	RSQ() {}
	RSQ(int n) : n(n){
		data.resize(n + 5);
	}
	void upd(int x){
		for(; x <= n; x += x & (-x)) ++ data[x];
	}
	int qry(int x){
		int ret = 0;
		for(; x > 0; x -= x & (-x)) ret += data[x];
		return ret;
	}
};

int main(){
	int n, m;
	cin >> m;
	assert(1 <= m && m <= 2e5);
	vector<pair<int, int>> fishes(m);
	for(int i = 0; i < m; i ++){
		cin >> fishes[i].first;
		assert(1 <= fishes[i].first && fishes[i].first <= 1e9);
	}
	for(int i = 0; i < m; i ++){
		cin >> fishes[i].second;
		assert(1 <= fishes[i].second && fishes[i].second <= 1e9);
	}
	for(int i = 0; i < m; i ++){
		assert(fishes[i].second == 1);
	}
	cin >> n;
	assert(1 <= n && n <= 2e5);
	vector<pair<int, int>> fishermen(n);
	for(int i = 0; i < n; i ++){
		cin >> fishermen[i].first;
		assert(1 <= fishermen[i].first && fishermen[i].first <= 1e9);
	}
	for(int i = 0; i < n; i ++){
		cin >> fishermen[i].second;
		assert(1 <= fishermen[i].second && fishermen[i].second <= 1e9);
	}
	for(int i = 0; i < n; i ++){
		assert(fishermen[i].second == 1);
	}
	vector<int> ans(n);
	{
		vector<array<int, 4>> events;
		vector<int> compress;
		for(auto [x, y] : fishes){
			events.push_back({x, 1, y - x, -1});
			compress.push_back(y - x);
		}
		for(int i = 0; i < n; i ++){
			auto [x, l] = fishermen[i];
			events.push_back({x, 0, l - x,  i});
			compress.push_back(l - x);
		}
		sort(events.begin(), events.end());
		sort(compress.begin(), compress.end());
		compress.resize(distance(compress.begin(), unique(all(compress))));
		RSQ ds(compress.size());
		for(auto [x, type, key, idx] : events){
			key = (lower_bound(compress.begin(), compress.end(), key) - compress.begin()) + 1;
			if(type == 0) ans[idx] += ds.qry(key);
			if(type == 1) ds.upd(key);
		}
	}
	{
		vector<array<int, 4>> events;
		vector<int> compress;
		for(auto [x, y] : fishes){
			events.push_back({x, 1, y + x, -1});
			compress.push_back(y + x);
		}
		for(int i = 0; i < n; i ++){
			auto [x, l] = fishermen[i];
			events.push_back({x, 0, l + x,  i});
			compress.push_back(l + x);
		}
		sort(events.begin(), events.end(), greater<array<int, 4>>());
		sort(compress.begin(), compress.end());
		compress.resize(distance(compress.begin(), unique(all(compress))));
		RSQ ds(compress.size());
		for(auto [x, type, key, idx] : events){
			key = (lower_bound(compress.begin(), compress.end(), key) - compress.begin()) + 1;
			if(type == 0) ans[idx] += ds.qry(key);
			if(type == 1) ds.upd(key);
		}
	}
	for(auto x : ans){
		cout << x << " ";
	} cout << endl;
}
